package com.fanruan.api;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-08-09
 */
public class FineKit {

    private final static String version;
    private final static String build;

    static {
        Package pkg = FineKit.class.getPackage();
        version = pkg.getImplementationVersion();
        build = pkg.getSpecificationVersion();
    }

    /**
     * 获取开发者工具套件的版本信息
     * @return 版本信息
     */
    public static String version() {
        return version;
    }

    /**
     * 获取开发者工具套件的构建日期信息，该信息一般作为某个API是否可用的依据
     * @return 构建日期
     */
    public static String build() {
        return build;
    }
}
