package com.fanruan.api.cluster.state;

import com.fr.store.impl.accessor.api.impl.FineStoreAdapter;
import com.fr.store.impl.accessor.api.impl.StandAloneStore;
import com.fr.third.redis.clients.jedis.Jedis;

/**
 * @author Dylan.Liu
 * @version 10.0
 * Created by Dylan.Liu on 2019/12/3
 */
public class StandAloneJedisKit {

    /**
     *  创建单机版 Jedis Api集合
     * @param jedis  Jedis 资源
     * @return 单机版 Jedis Api集合
     */
    public static FineStoreAdapter createStandAloneJedis(Jedis jedis) {

        if (jedis == null) {
            throw new NullPointerException("jedis is null");
        }
        return new StandAloneStore(jedis);
    }
}
