package com.fanruan.api.conf.xml;

import com.fanruan.api.conf.impl.xml.XmlColConf;
import com.fanruan.api.conf.impl.xml.XmlConf;
import com.fr.config.holder.Conf;
import com.fr.stable.xml.XMLable;

import java.util.Collection;
/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-08-30
 * 将xml文件写入fine_conf_entity的帮助类，不建议使用
 */
public class XmlHolderKit {

    /**
     * 创建一个要写入配置的xml多项
     * @param t 配置对象
     * @param clazz 类型
     * @param xmlTag xml标签
     * @param <T> 类型
     * @return 配置对象
     */
    public static <T extends XMLable> Conf<T> obj(T t, Class<T> clazz, String xmlTag) {
        return new XmlConf(t, clazz, xmlTag);
    }

    /**
     * 创建一个集合类型的xml配置
     *
     * @param t     初始值
     * @param clazz 对象class类型
     * @param <T>   类型
     * @return  配置对象
     */
    public static <T extends XMLable> XmlColConf<Collection<T>> collection(Collection<T> t, Class<T> clazz) {
        return collection(t,clazz,true);
    }


    /**
     * 创建一个集合类型的xml配置
     *
     * @param t     初始值
     * @param clazz 对象class类型
     * @param order 是否是有序的配置
     * @param <T>   类型
     * @return  配置对象
     */
    public static <T extends XMLable> XmlColConf<Collection<T>> collection(Collection<T> t, Class<T> clazz, boolean order) {
        return new XmlColConf<Collection<T>>(t, clazz, order);
    }
}
