package com.fanruan.api.decision.macro;

import com.fr.decision.webservice.utils.DecisionServiceConstants;
import com.fr.general.web.ParameterConstants;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/10/14
 * 决策平台常用常量
 */
public class Constants {

    /**
     * 表示用户名参数名的常量
     */
    public static final String FINE_USERNAME = ParameterConstants.FINE_USERNAME;

    /**
     * 表示密码参数名的常量
     */
    public static final String FINE_PASSWORD = ParameterConstants.FINE_PASSWORD;

    /**
     * 用于表示决策平台主页的常量，需要使用RenderKit#render方法将这个常量生成为实际的url地址
     *
     * @see com.fanruan.api.util.RenderKit#render(String)
     */
    public static final String MAIN_PAGE_URL = DecisionServiceConstants.MAIN_PAGE_URL;

    /**
     * 表示认证票据参数名的常量
     */
    public static final String FINE_AUTH_TOKEN_NAME = DecisionServiceConstants.FINE_AUTH_TOKEN_NAME;

    /**
     * 记住密码时的最长时间（服务器重启后记住密码也会失效）
     */
    public static final long REMEMBER_PASSWORD_LIFE = DecisionServiceConstants.REMEMBER_PASSWORD_LIFE;
}
