package com.fanruan.api.design.macro;

import com.fanruan.api.macro.LineConstants;
import com.fanruan.api.util.IOKit;

import javax.swing.*;
import java.awt.*;

/**
 * 设计器界面使用的一些常量
 */
public interface UIConstants {

    /**
     * 边框线颜色
     */
    Color LINE_COLOR = new Color(153, 153, 153);

    /**
     * 带标题的边框的颜色
     */
    Color TITLED_BORDER_COLOR = new Color(0xe8e8e9);

    /**
     * 圆角弧度
     */
    int ARC = 0;

    /**
     * 线条
     */
    Stroke BS = new BasicStroke(1f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_ROUND, 2f, new float[]{3, 1}, 0);

    /**
     * 用于表示字体的图标
     */
    Icon FONT_ICON = IOKit.readIcon("/com/fr/design/images/gui/color/foreground.png");

    /**
     * 边框线数组
     */
    int[] BORDER_LINE_STYLE_ARRAY = new int[]{
            LineConstants.LINE_THIN,
            LineConstants.LINE_MEDIUM,
            LineConstants.LINE_DASH,
            LineConstants.LINE_HAIR,
            LineConstants.LINE_HAIR2,
            LineConstants.LINE_THICK,
            LineConstants.LINE_DOUBLE,
            LineConstants.LINE_DOT,
            LineConstants.LINE_MEDIUM_DASH,
            LineConstants.LINE_DASH_DOT,
            LineConstants.LINE_MEDIUM_DASH_DOT,
            LineConstants.LINE_DASH_DOT_DOT,
            LineConstants.LINE_MEDIUM_DASH_DOT_DOT,
            LineConstants.LINE_SLANTED_DASH_DOT,
    };
}
