package com.fanruan.api.design.ui.editor;

import com.fanruan.api.design.DesignKit;
import com.fanruan.api.util.GeneralKit;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/11/1
 * 用于编辑和展示整数值的编辑器
 * TODO:待补充文档
 */
public class TypeIntegerEditor extends BaseNumberEditor<Integer> {

    private static final long serialVersionUID = 1L;

    public TypeIntegerEditor() {
        this(0);
    }

    public TypeIntegerEditor(Integer value) {
        super(value, DesignKit.i18nText("Fine-Design_Basic_Parameter_Integer"));
    }

    @Override
    public boolean accept(Object object) {
        return object instanceof Integer;
    }

    @Override
    public Integer getValue() {
        return (int) this.numberField.getValue();
    }

    @Override
    public void setValue(Integer value) {
        if (value == null) {
            value = 0;
        }
        this.numberField.setInteger(true);
        this.numberField.setValue(value);
        oldValue = GeneralKit.objectToString(value);
    }

    public String getIconName() {
        return "type_int";
    }
}