package com.fanruan.api.design.work.form.editor;

import com.fanruan.api.design.err.ValidationException;
import com.fr.design.mainframe.widget.editors.AbstractPropertyEditor;

import java.awt.*;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/10/30
 * 自定义属性编辑器接口
 */
public abstract class BasePropertyEditor extends AbstractPropertyEditor {

    /**
     * 校验编辑器中输入值的合法性
     *
     * @throws ValidationException 值不合法则抛出此异常
     */
    @Override
    public abstract void validateValue() throws ValidationException;

    /**
     * 从外部给编辑器传入值
     *
     * @param value 新值
     */
    @Override
    public abstract void setValue(Object value);

    /**
     * 获取编辑器的值
     *
     * @return 编辑器的值
     */
    @Override
    public abstract Object getValue();

    /**
     * 编辑器的UI控制器，是一个swing组件，比如：下拉框、复选框，用于设置做不同类别的属性设置
     *
     * @return UI控制器
     */
    @Override
    public abstract Component getCustomEditor();
}
