package com.fanruan.api.design.work.form.editor.impl;

import com.fanruan.api.design.err.ValidationException;
import com.fanruan.api.design.ui.component.UITextField;
import com.fanruan.api.design.work.form.editor.BasePropertyEditor;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.awt.*;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-09-05
 * 字符串编辑器
 */
public class StringEditor extends BasePropertyEditor {
    private JPanel panel;
    private UITextField textField;

    public StringEditor() {
        panel = new JPanel(new BorderLayout());
        textField = new UITextField();
        panel.add(textField, BorderLayout.CENTER);
        textField.setBorder(null);
        textField.getDocument().addDocumentListener(new DocumentListener() {

            @Override
            public void removeUpdate(DocumentEvent e) {
                firePropertyChanged();
            }

            @Override
            public void insertUpdate(DocumentEvent e) {
                firePropertyChanged();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                firePropertyChanged();
            }
        });
    }

    @Override
    public void setValue(Object value) {
        textField.setText((String) value);
    }

    @Override
    public Object getValue() {
        return textField.getText();
    }

    @Override
    public Component getCustomEditor() {
        return textField;
    }

    @Override
    public void validateValue() throws ValidationException {

    }
}