package com.fanruan.api.report.export;

import com.fr.io.exporter.AbstractAppExporter;
import com.fr.main.workbook.ResultWorkBook;
import com.fr.page.PageSetProvider;

import java.io.OutputStream;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/9/26
 * 导出接口
 */
public abstract class BaseAppExporter<T> extends AbstractAppExporter<T> {

    public BaseAppExporter() {

    }

    /**
     * 导出
     *
     * @param outputStream    输出流
     * @param pageSetProvider 分页对象
     * @throws Exception 导出失败则抛出此异常
     */
    @Override
    public void export(OutputStream outputStream, PageSetProvider pageSetProvider) throws Exception {
        throw new UnsupportedOperationException();
    }

    /**
     * 导出
     *
     * @param outputStream   输出流
     * @param resultWorkBook 结果报表
     * @throws Exception 导出失败则抛出此异常
     */
    @Override
    public abstract void export(OutputStream outputStream, ResultWorkBook resultWorkBook) throws Exception;

}
