package com.fanruan.api.report.form;

import com.fr.data.act.Describer;
import com.fr.form.ui.Widget;
import com.fr.json.JSONException;
import com.fr.json.JSONObject;
import com.fr.script.Calculator;
import com.fr.stable.core.NodeVisitor;
import com.fr.stable.web.Repository;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-09-10
 * 控件接口，如果控件支持"控件值"属性，则需要实现接口 {@link com.fr.form.ui.DataControl}
 */
public abstract class BaseWidget extends Widget implements Describer {

    @Override
    public boolean isEditor() {
        return false;
    }

    @Override
    public final JSONObject createJSONConfig(Repository repository, Calculator calculator, NodeVisitor nodeVisitor) throws JSONException {
        JSONObject jo = super.createJSONConfig(repository, calculator, nodeVisitor);
        mixinJSON(repository, calculator, jo);
        return jo;
    }
}
