package com.fanruan.api.report.form;

import com.fr.form.ui.LayoutBorderStyle;
import com.fr.form.ui.WidgetTitle;
import com.fr.general.act.BorderPacker;
import com.fr.general.act.TitlePacker;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/10/28
 * 控件相关工具类
 */
public class WidgetKit {

    /**
     * 创建一个空的控件标题对象
     *
     * @return 控件标题
     */
    public static TitlePacker newWidgetTitle() {
        return new WidgetTitle();
    }

    /**
     * 根据指定的名字创建一个控件标题对象
     *
     * @param title 标题内容
     * @return 控件标题
     */
    public static TitlePacker newWidgetTitle(String title) {
        return new WidgetTitle(title);
    }

    /**
     * 创建一个空的边框样式对象
     *
     * @return 边框样式
     */
    public static BorderPacker newLayoutBorderStyle() {
        return new LayoutBorderStyle();
    }
}
