package com.fanruan.api.report.submit;

import com.fr.data.AbstractSubmitTask;
import com.fr.script.Calculator;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/10/12
 * 数据提交接口
 */
public abstract class BaseSubmitTask extends AbstractSubmitTask {

    /**
     * 提交类型
     *
     * @return 用于表示提交类型的字符串
     */
    public abstract String getJobType();

    /**
     * 提交操作
     *
     * @param calculator 算子
     * @throws Exception 提交发生错误则抛出此异常
     */
    public abstract void doJob(Calculator calculator) throws Exception;

    /**
     * 提交结束之后的操作
     *
     * @param calculator 算子
     * @throws Exception 提交结束处理过程中发生错误则抛出此异常
     */
    public abstract void doFinish(Calculator calculator) throws Exception;

}
