package com.fanruan.api.report.view;

import com.fr.main.TemplateWorkBook;
import com.fr.main.workbook.ResultWorkBook;
import com.fr.stable.ViewActor;

import java.util.Map;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/10/12
 * 分析预览接口
 */
public abstract class BaseViewActor extends ViewActor {

    @Override
    public final ResultWorkBook executeWorkBook(TemplateWorkBook templateWorkBook, Map map, int sheetIndex) {
        return run(templateWorkBook, map, sheetIndex);
    }

    /**
     * 将模板计算为结果结果集
     *
     * @param templateWorkBook 模板
     * @param map              参数
     * @param sheetIndex       sheet编号
     * @return 结果集
     */
    public abstract ResultWorkBook run(TemplateWorkBook templateWorkBook, Map map, int sheetIndex);

    /**
     * 调用原始的分析执行操作
     *
     * @param templateWorkBook 模板
     * @param map              参数
     * @param sheetIndex       sheet编号
     * @return 结果集
     */
    public final ResultWorkBook run0(TemplateWorkBook templateWorkBook, Map map, int sheetIndex) {
        return super.executeWorkBook(templateWorkBook, map, sheetIndex);
    }
}
