package com.fanruan.api.cluster.state;

import com.fr.store.impl.accessor.api.FineStore;
import com.fr.third.redis.clients.jedis.Jedis;
import org.easymock.EasyMock;
import org.junit.Assert;
import org.junit.Test;

import static org.easymock.EasyMock.anyObject;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.mock;

/**
 * @author Dylan.Liu
 * @version 10.0
 * Created by Dylan.Liu on 2019/12/3
 */
public class StandAloneJedisKitTest {

    @Test
    public void testCreateStandAloneJedis() {

        Jedis mockJedis = mock(Jedis.class);
        expect(mockJedis.type(anyObject(byte[].class))).andReturn("test_echo");
        EasyMock.replay(mockJedis);

        FineStore standAloneJedis = StandAloneJedisKit.createStandAloneJedis(mockJedis);

        Assert.assertEquals("test_echo", standAloneJedis.type(new byte[]{}));
    }
}