package com.fanruan.api.data.open;

import com.fr.general.data.DataModel;
import com.fr.script.Calculator;
import org.junit.Assert;
import org.junit.Test;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-09-04
 */
public class BaseTableDataTest {

    @Test
    public void testCreate() throws Exception {
        Calculator calculator = Calculator.createCalculator();
        DemoTableData tableData = new DemoTableData();
        DataModel model = tableData.createDataModel(calculator);
        Object r = model.getValueAt(0, 0);
        Assert.assertTrue(model.hasRow(0));
        Assert.assertFalse(model.hasRow(1));
        Assert.assertEquals(1, model.getColumnCount());
        Assert.assertEquals(1, model.getRowCount());
        Assert.assertEquals("abc", r);
    }


    private static class DemoTableData extends BaseTableData {

        @Override
        public DataModel createDataModel(Calculator calculator) {
            return new BaseDataModel() {

                @Override
                public int getColumnCount() {
                    return 1;
                }

                @Override
                public String getColumnName(int i) {
                    return "test";
                }

                @Override
                public boolean hasRow(int i) {
                    return i < 1;
                }

                @Override
                public int getRowCount() {
                    return 1;
                }

                @Override
                public Object getValueAt(int i, int i1) {
                    return "abc";
                }

                @Override
                public void release() throws Exception {

                }
            };
        }
    }
}