package com.fanruan.api.util;

import com.fr.stable.CodeUtils;
import org.junit.Assert;
import org.junit.Test;

public class CodeKitTest {
    @Test
    public void javascriptEncode() {
        Assert.assertEquals(CodeKit.javascriptEncode("console.log(123)"), "console.log(123)");
    }

    @Test
    public void cjkDecode() {
        String s = "中文 한글 日本語";
        String encode = CodeUtils.cjkEncode(s);

        try {
            String decode = CodeKit.cjkDecode(encode);
            Assert.assertTrue(s.equals(decode));
        } catch (Exception e) {

        }
    }

    @Test
    public void encodeURIComponent() {
        String s = "123";
        String encode = CodeUtils.encodeURIComponent(s);

        try {
            String decode = CodeKit.encodeURIComponent(encode);
            Assert.assertTrue(s.equals(decode));
        } catch (Exception e) {

        }
    }

    @Test
    public void jsonEncode() {
        String s = "aaa";
        Assert.assertEquals(CodeKit.jsonEncode(s),"\"aaa\"");
    }
}
